Subject: Re: [RFC] TCP congestion schedulers

From: Arnaldo Carvalho de Melo <[email-masked]>
Date: Fri, 18 Mar 2005 13:59:02 -0300

On Fri, 18 Mar 2005 08:45:55 -0800, Stephen Hemminger
<[email-masked]> wrote:
> On Fri, 18 Mar 2005 13:13:45 -0300
> Arnaldo Carvalho de Melo <[email-masked]> wrote:
> 
> > On 18 Mar 2005 08:43:04 -0500, jamal <[email-masked]> wrote:
> > > On Fri, 2005-03-18 at 07:53, Arnaldo Carvalho de Melo wrote:
> > >
> > > > > I'm also not so religious anymore about retaining the existing
> > > > > sysctl functionality to enable/disable ca algs.
> > > >
> > > > I haven't looked over this patch completely, so I may well be saying something
> > > > stupid, but if possible, please don't use the tcp/TCP prefix where you
> > > > think this
> > > > code can be used by other inet transport protocols, such as DCCP.
> > >
> > > Yes, that would be really nice.
> > >
> > > Also heres another thought: if we can have multiple sockets, destined to
> > > the same receiver, to share the same congestion state. This is motivated
> > > from the CM idea the MIT folks were preaching a few years ago - look at
> > > RFC 3124 and the MIT website which had some crude linux code back then
> > > as well as tons of papers. I think
> > > that scheme may need to hook up to tc to work well.
> >
> > The DCCP drafts mention that they choose not to require the CM, but yes, it is
> > something to consider anyway, its interesting stuff.
> >
> > Again without looking at the patch fully, the tcp_sock passing to this
> > infrastructure
> > would have to go away and instead chunk out the needed members out of tcp_sock
> > and into a congestion_info struct that would be a member of both tcp_sock and
> > dccp_sock, and this one would be the one passed to this infrastructure.
> >
> > In the end we may well give Sally et al some new CCIDs for free :-P
> 
> Let's abstract it for TCP first, then as a later patch reduce the scope and
> generalize it.

Fine with me, just wanted to trow these thoughts so that when working on it
you think about it :-)

-- 
- Arnaldo